%===============================================================================
% Pindah silang menggunakan ORDER CROSSOVER 
%
% Masukan 
%   Bapak : kromosom, matriks berukuran 1 x JumGen
%   Ibu : kromosom, matriks berukuran 1 x JumGen
%   JumGen : jumlah gen
%   
% Keluaran 
%   Anak : kromosom hasil pindah silang, matriks berukuran 1 x JumGen
%
% Tanggal update 09 Januari 2005
% Suyanto - Teknik Informatika - Sekolah Tinggi Teknologi Telkom 
% Jl Telekomunikasi No 1 Dayeuh Kolot - Bandung 40257
%===============================================================================

function Anak = TSPPindahSilang(Bapak,Ibu,JumGen)

cp1 = 1 + fix(rand*(JumGen-1));
cp2 = 1 + fix(rand*(JumGen-1));
while cp2==cp1,
    cp2 = 1 + fix(rand*(JumGen-1));
end

if cp1 < cp2,
    cps = cp1;
    cpd = cp2;
else
    cps = cp2;
    cpd = cp1;
end
    
Anak(1,cps+1:cpd) = Ibu(cps+1:cpd);
Anak(2,cps+1:cpd) = Bapak(cps+1:cpd);

SisaGenbapak = [];
SisaGenIbu = [];
for ii=1:JumGen,
    if ~ismember(Bapak(ii),Anak(1,:)),
        SisaGenbapak = [SisaGenbapak Bapak(ii)];
    end
    if ~ismember(Ibu(ii),Anak(2,:)),
        SisaGenIbu = [SisaGenIbu Ibu(ii)];
    end
end

Anak(1,cpd+1:JumGen) = SisaGenbapak(1:JumGen-cpd);
Anak(1,1:cps) = SisaGenbapak(1+JumGen-cpd:length(SisaGenbapak));

Anak(2,cpd+1:JumGen) = SisaGenIbu(1:JumGen-cpd);
Anak(2,1:cps) = SisaGenIbu(1+JumGen-cpd:length(SisaGenIbu));