%===============================================================================
% Mendekodekan kromosom yang berisi bilangan biner menjadi individu x yang
% bernilai real dalam interval yang ditentukan [Ra,Rb]
%
% Masukan 
%   Kromosom : kromosom, matriks berukuran 1 x PanjKrom
%   JGMsatu : jumlah gen dalam satu messy
%   Nvar : jumlah variabel
%   Nbit : jumlah bit yang mengkodekan satu variabel
%   Ra : batas atas interval
%   Rb : batas bawah interval
%   
% Keluaran 
%   x : individu hasil dekode kromosom
%   JGenHilang: Jumlah gen yang tidak muncul pada kromosom
%
% Tanggal update 09 Januari 2005
% Suyanto - Teknik Informatika - Sekolah Tinggi Teknologi Telkom 
% Jl Telekomunikasi No 1 Dayeuh Kolot - Bandung 40257
%===============================================================================

function [x,JGenHilang] = MessyDekode(Kromosom,JGMsatu,Nvar,Nbit,Ra,Rb)

PanjKrom = length(Kromosom);
Identitas = Kromosom(1:2:PanjKrom);
JGenHilang = 0;

for ii=1:JGMsatu,
    if ismember(ii,Identitas),
        Ind = find(Identitas == ii);    % Ind bisa berisi lebih dari satu
        KromTemp(ii) = Kromosom(Ind(1)*2);
    else
        KromTemp(ii) = 0;
        JGenHilang = JGenHilang + 1;
    end
end

Kromosom = KromTemp;

for ii=1:Nvar,
  x(ii) = 0;
  for jj=1:Nbit,
    x(ii) = x(ii) + Kromosom((ii-1)*Nbit+jj)*2^(-jj);
  end
  x(ii) = Rb + (Ra-Rb)*x(ii);
end