%===============================================================================
% Mengevaluasi individu sehingga didapatkan nilai fitness-nya 
%
% Masukan 
%   FFNNstruk : struktur FFNN
%   JumMasukan : jumlah masukan
%   JPmasukan : jumlah pola masukan
%   IM : matriks Input berukuran JPmasukan x JumMasukan
%   TM : matriks target berukuran JPmasukan x 1
%   JGHilang : jumlah gen yang hilang
%   
% Keluaran 
%   fitness : nilai fitness
%
% Tanggal update 09 Januari 2005
% Suyanto - Teknik Informatika - Sekolah Tinggi Teknologi Telkom 
% Jl Telekomunikasi No 1 Dayeuh Kolot - Bandung 40257
%===============================================================================

function fitness = MessyEvalInd(FFNNstruk,JumMasukan,JPmasukan,IM,TM,JGHilang)

c = 1.0;
n2 = JumMasukan^2;

Wtemp = FFNNstruk(1:n2);
for ii=1:JumMasukan,
    Wih(ii,:) = Wtemp((ii-1)*JumMasukan+1:ii*JumMasukan);
end

bih = FFNNstruk(n2+1:n2+JumMasukan);
Who = FFNNstruk(n2+JumMasukan+1:n2+2*JumMasukan);
bho = FFNNstruk((JumMasukan+1)^2);

RMSE = 0;
for evaluasi=1:JPmasukan,
    for ii=1:JumMasukan,
        JumWIb = 0;
        for jj=1:JumMasukan,
            JumWIb = JumWIb + (Wih(ii,jj) * IM(evaluasi,jj) + bih(jj));
        end
        Xih(ii) = 1 / (1+exp(-c*JumWIb));
    end
    
    SumWXb = 0;
    for jj=1:JumMasukan,
        SumWXb = SumWXb + (Who(jj) * Xih(jj) + bho);
    end
    Xho = 1 / (1+exp(-c*SumWXb));
    RMSE = RMSE + (TM(evaluasi)-Xho)^2;
end

Delta = sqrt(1/JPmasukan * RMSE);
fitness = (1/Delta) * exp(-JGHilang);