%===============================================================================
% Fungsi Grid-based Tournament selection
%
% Masukan
%    UkPop    : Population size
%    Fitness  : Fitness 1-D array
%    UkTour   : Tournament size
%    ProbTour : Tournament probability
%
% Keluaran
%    IndTerpilih : Index of Selected Individual
% 
% Tanggal update 09 Januari 2005
% Suyanto - Teknik Informatika - Sekolah Tinggi Teknologi Telkom 
% Jl Telekomunikasi No 1 Dayeuh Kolot - Bandung 40257
%===============================================================================

function IndTerpilih = GBTourSelection(UkPop,Fitness,UkTour,ProbTour)

for ii=1:UkTour,
    Itemp(ii) = 1 + fix(rand*UkPop);  % Indeks dari individu terpilih
    Ftemp(ii) = Fitness(Itemp(ii));   % Nilai fitness dari individu terpilih 
end

[M,IndTerbaik] = max(Ftemp);   % indeks individu terbaik dalam tournament

IndLainnya = [];    % indeks individu selain yang terbaik dalam tournament
if IndTerbaik==1,
    IndLainnya = [IndLainnya 2:UkTour];
else
    IndLainnya = [IndLainnya 1:IndTerbaik-1];
    IndLainnya = [IndLainnya IndTerbaik+1:UkTour];
end

if rand < ProbTour,
    IndTerpilih = Itemp(IndTerbaik);
else
    IndTerpilih = Itemp(IndLainnya(1+fix(rand*(UkTour-1))));
end