%===================================================================================
% Mendekodekan kromosmom sehingga dihasilkan sebuah individu yang 
% merepresentasikan sebuah struktur Neural Network (NN)
% 
% Masukan
%   Kromosom : kromosom, matriks berukuran 1 x JumGen
%   JumGen : jumlah gen
%   PBK : Jumlah huruf besar dalam satu grup setelah simbol start S
%   PKK : Jumlah huruf kecil dalam satu grup setelah huruf besar
%   a,b .., p : masing-masing variabel adalah matriks 2x2 (biner)
%
% Keluaran
%    NNstruk : struktur NN yang dihasilkan, matriks 8x8
%
% Tanggal update 11 Januari 2005
% Suyanto - Teknik Informatika - Sekolah Tinggi Teknologi Telkom 
% Jl Telekomunikasi No 1 Dayeuh Kolot - Bandung 40257
%===================================================================================

function NNstruk = GEDekode(Kromosom,JumGen,PBK,PKK,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p)

Xupper = [];
for ii=2:fix(PBK/2)+1,
    ind = find(Kromosom(PBK+2:JumGen)==Kromosom(ii));
    ind = ind + PBK + 1;
    ind = [ind 0];
    ind = ind(1);
    if ind == 0,
       ind = PBK + 2;
    end
    US = Kromosom(ind+1:ind+fix(PKK/2));
    LS = Kromosom(ind+fix(PKK/2)+1:ind+PKK);
    Lstring = [US ; LS];
    Xupper = [Xupper Lstring];
end

Xlower = [];
for ii=fix(PBK/2)+2:PBK+1,
    ind = find(Kromosom(PBK+2:JumGen)==Kromosom(ii));
    ind = ind + PBK + 1;
    ind = [ind 0];
    ind = ind(1);
    if ind == 0,
       ind = PBK + 2;
    end
    US = Kromosom(ind+1:ind+fix(PKK/2));
    LS = Kromosom(ind+fix(PKK/2)+1:ind+PKK);
    Lstring = [US ; LS];
    Xlower = [Xlower Lstring];
end

X = [Xupper ; Xlower];

NNstruk = [];
for ii=1:PKK,
    NNrow = []; 
    for jj=1:PKK,
        NNrow = [NNrow eval(X(ii,jj))];
    end
    NNstruk = [NNstruk ; NNrow];
end