%=======================================================================================
% Membangkitkan satu populasi yang berisi sejumlah UkPop kromosom
% 
% Masukan
%   UkPop : Jumlah kromosom dalam populasi 
%   HHbesar : Himpunan huruf besar
%   HHkecil : Himpunan huruf kecil
%   JHB : Jumlah huruf besar dalam himpunan
%   JHK : Jumlah huruf kecil dalam himpunan
%   PBK : Jumlah huruf besar dalam satu grup setelah simbol start S
%   PKK : Jumlah huruf kecil dalam satu grup setelah huruf besar
%   JumGen : Jumlah gen dalam kromosom
%
% Keluaran
%    Populasi : Kumpulan kromosom, matriks berukuran UkPop x JumGen
%
% Tanggal update 11 Januari 2005
% Suyanto - Teknik Informatika - Sekolah Tinggi Teknologi Telkom 
% Jl Telekomunikasi No 1 Dayeuh Kolot - Bandung 40257
%=======================================================================================

function Populasi = GEInisialisasiPopulasi(UkPop,HHbesar,HHkecil,JHB,JHK,PBK,PKK,JumGen)

for pp=1:UkPop,
    Kromosom = 'S';                                 % simbol start
    [x,ind] = sort(rand(1,JHB));
    Kromosom = [Kromosom HHbesar(ind(1:PBK))];      % 4 simbol huruf besar
    
    Pgrup = PBK + 1;          % Panjang grup = 5 (1 huruf besar + 4 huruf kecil)
    IndeksMulai  = PBK + 2;   
    for ii=IndeksMulai:Pgrup:JumGen,
        [x,ind] = max(rand(1,JHB));
        Kromosom = [Kromosom HHbesar(ind(1))];      % 1 simbol huruf besar
        [x,ind] = sort(rand(1,JHK));
        Kromosom = [Kromosom HHkecil(ind(1:PKK))];  % 4 simbol huruf kecil
    end
    Populasi(pp,:) = Kromosom;
end