%===============================================================================
% Mutasi gen dengan probabilitas sebesar Pmutasi
% Gen-gen yang terpilih diubah nilainya: 0 menjadi 1, dan 1 menjadi 0 
%
% Masukan 
%   Kromosom : kromosom, matriks berukuran 1 x JumGen
%   JumGen : jumlah gen
%   HHbesar : Himpunan huruf besar
%   HHkecil : Himpunan huruf kecil
%   JHB : Jumlah huruf besar dalam himpunan
%   JHK : Jumlah huruf kecil dalam himpunan
%   PBK : Jumlah huruf besar dalam satu grup setelah simbol start S
%   Pmutasi: Probabilitas mutasi
%   
% Keluaran 
%   MutKrom : kromosom hasil mutasi, matriks berukuran 1 x JumGen
%
% Tanggal update 28 Desember 2004
% Suyanto - Teknik Informatika - Sekolah Tinggi Teknologi Telkom 
% Jl Telekomunikasi No 1 Dayeuh Kolot - Bandung 40257
%===============================================================================

function MutKrom = GEMutasi(Kromosom,JumGen,HHbesar,HHkecil,JHB,JHK,PBK,Pmutasi)

MutKrom = Kromosom;
for ii=2:JumGen,
  if (rand < Pmutasi),
    if (ii <= PBK+1) | (mod(ii,PBK+1)==1),
       [x,IC] = max(rand(1,JHB));
       MutKrom(ii) = HHbesar(IC(1));
    else
       [x,IL] = max(rand(1,JHK));
       MutKrom(ii) = HHkecil(IL(1));
    end
  end
end